#include "descriptor/descriptor.h"

	ITEM	corno_dx, corno_sx, corpo_trimmato;
	ITEM	braccio_dx, mano_dx, pollice_dx, indice_dx, medio_dx, mignolo_dx;
	ITEM	braccio_sx, mano_sx, pollice_sx, indice_sx, medio_sx, mignolo_sx;
	ITEM	occhio, ciglio, sopracciglio, sottociglio;
	ITEM	bocca_overlay, labbro, dente_1, dente_2, dente_3, dente_4;
	ITEM	gamba_dx, piede_dx, unghia_dx_1, unghia_dx_2, unghia_dx_3;
	ITEM	gamba_sx, piede_sx, unghia_sx_1, unghia_sx_2, unghia_sx_3;

	ITEM	porta_corpo, porta_contorno, pomello_porta;
	ITEM	sostegno_porta_dx, sostegno_porta_sx, ruota_dx, ruota_sx, lucina;
	ITEM	sostegno_bombola_sotto, sostegno_bombola_sopra, bombola, bombola2;

	ITEM	pinza_1, pinza_2, filo;

	ITEM	pavimento, soffitto, fondo, muro;
		
	ITEM	braccio_dx_list, braccio_sx_list, corpo_list, gamba_dx_list, gamba_sx_list;
	ITEM	pelle_list, denti_list, unghie_list, piede_dx_list, piede_sx_list;
	ITEM	pinza_list;
	ITEM	ambiente_list, sostegni_list, porta_list;
	ITEM	scena;
	ITEM	mike;

	ITEM	temp_attr, colore_pavimento, colore_muro, colore_soffitto, attr_lucina;	

	ITEM	luce_1, luce_2;

	VEC_real_t	gamba_dx_rot = 0, gamba_sx_rot = 0, piede_dx_rot = 0, piede_sx_rot = 0;
	VEC_real_t	gamba_dx_posx = 0, gamba_sx_posx = 0, piede_dx_posx = 0, piede_sx_posx = 0;
	VEC_real_t	gamba_dx_posz = 0, gamba_sx_posz = 0, piede_dx_posz = 0, piede_sx_posz = 0;
	VEC_real_t	braccio_dx_posx = 0, braccio_sx_posx = 0, corpo_posx = 0;
	VEC_real_t	braccio_dx_posz = 0, braccio_sx_posz = 0, corpo_posz = 0;

int main(void)
{

	set_background(0.4,0.361,0.753,TRUE);
	set_ambient_light(1,1,1,0.7);
	luce_1 = create_point_light(23,25,20,1,1,1,1,0,"luce1");
	luce_2 = create_warn_light(77,11.5,67.1, 1,0,0, 1,0.3,0.1, 0.8,40,5,70,1,0,0,1,5, "lucina" );

	/*************************************************************
	 ******	mike
	 *************************************************************/
	temp_attr = create_attribute("temp_attr");
	attr_lucina = create_attribute("attr_lucina");
	colore_pavimento = create_attribute("colore_pavimento");
	colore_muro = create_attribute("colore_muro");
	colore_soffitto = create_attribute("colore_soffitto");

	corno_dx = read_nurbs("corno_dx.db");
	corno_sx = read_nurbs("corno_sx.db");
	corpo_trimmato = read_nurbs("corpo_trimmato.dbe");
	braccio_dx = read_nurbs("braccio_dx.db");
	mano_dx = read_nurbs("mano_dx.db");
	pollice_dx = read_nurbs("pollice_dx.db");
	indice_dx = read_nurbs("indice_dx.db");
	medio_dx = read_nurbs("medio_dx.db");
	mignolo_dx = read_nurbs("mignolo_dx.db");
	braccio_sx = read_nurbs("braccio_sx.db");
	mano_sx = read_nurbs("mano_sx.db");
	pollice_sx = read_nurbs("pollice_sx.db");
	indice_sx = read_nurbs("indice_sx.db");
	medio_sx = read_nurbs("medio_sx.db");
	mignolo_sx = read_nurbs("mignolo_sx.db");
	occhio = read_nurbs("occhio.db");
	ciglio = read_nurbs("ciglio.db");
	sopracciglio = read_nurbs("sopracciglio.db");
	sottociglio = read_nurbs("sottociglio.db");
	bocca_overlay = read_nurbs("bocca_overlay.db");
	labbro = read_nurbs("labbro.db");
	dente_1 = read_nurbs("dente_1.db");
	dente_2 = read_nurbs("dente_2.db");
	dente_3 = read_nurbs("dente_3.db");
	dente_4 = read_nurbs("dente_4.db");
	gamba_dx = read_nurbs("gamba_dx.db");
	piede_dx = read_nurbs("piede_dx.db");
	unghia_dx_1 = read_nurbs("unghia_dx_1.db");
	unghia_dx_2 = read_nurbs("unghia_dx_2.db");
	unghia_dx_3 = read_nurbs("unghia_dx_3.db");
	gamba_sx = read_nurbs("gamba_sx.db");
	piede_sx = read_nurbs("piede_sx.db");
	unghia_sx_1 = read_nurbs("unghia_sx_1.db");
	unghia_sx_2 = read_nurbs("unghia_sx_2.db");
	unghia_sx_3 = read_nurbs("unghia_sx_3.db");
	porta_corpo = read_nurbs("porta_corpo.db");
	porta_contorno = read_nurbs("porta_contorno.db");
	pomello_porta = read_nurbs("pomello_porta.db");
	sostegno_porta_dx = read_nurbs("sostegno_porta_dx.db");
	sostegno_porta_sx = read_nurbs("sostegno_porta_sx.db");
	lucina = read_nurbs("lucina.db");
	ruota_sx = read_nurbs("ruota_sx.db");
	ruota_dx = read_nurbs("ruota_dx.db");
	pavimento = read_nurbs("pavimento.db");
	soffitto = read_nurbs("soffitto.db");
	fondo = read_nurbs("fondo.db");
	muro = read_nurbs("muro.db");
	sostegno_bombola_sotto = read_nurbs("sostegno_bombola_sotto.db");
	sostegno_bombola_sopra = read_nurbs("sostegno_bombola_sopra.db");
	bombola = read_nurbs("bombola.db");
	bombola2 = read_nurbs("bombola2.db");
	pinza_1 = read_nurbs("pinza_1.db");
	pinza_2 = read_nurbs("pinza_2.db");
	filo = read_nurbs("filo.db");

	braccio_dx_list = create_list(braccio_dx, "braccio_dx_list");
	braccio_dx_list = insert_in_list(braccio_dx_list, mano_dx);
	braccio_dx_list = insert_in_list(braccio_dx_list, pollice_dx);
	braccio_dx_list = insert_in_list(braccio_dx_list, indice_dx);
	braccio_dx_list = insert_in_list(braccio_dx_list, medio_dx);
	braccio_dx_list = insert_in_list(braccio_dx_list, mignolo_dx);

	braccio_sx_list = create_list(braccio_sx, "braccio_sx_list");
	braccio_sx_list = insert_in_list(braccio_sx_list, mano_sx);
	braccio_sx_list = insert_in_list(braccio_sx_list, pollice_sx);
	braccio_sx_list = insert_in_list(braccio_sx_list, indice_sx);
	braccio_sx_list = insert_in_list(braccio_sx_list, medio_sx);
	braccio_sx_list = insert_in_list(braccio_sx_list, mignolo_sx);

	corpo_list = create_list(corpo_trimmato, "corpo_list");
	corpo_list = insert_in_list(corpo_list, corno_dx);
	corpo_list = insert_in_list(corpo_list, corno_sx);
	corpo_list = insert_in_list(corpo_list, occhio);
	corpo_list = insert_in_list(corpo_list, ciglio);
	corpo_list = insert_in_list(corpo_list, sopracciglio);
	corpo_list = insert_in_list(corpo_list, sottociglio);
	corpo_list = insert_in_list(corpo_list, bocca_overlay);
	corpo_list = insert_in_list(corpo_list, labbro);
	corpo_list = insert_in_list(corpo_list, dente_1);
	corpo_list = insert_in_list(corpo_list, dente_2);
	corpo_list = insert_in_list(corpo_list, dente_3);
	corpo_list = insert_in_list(corpo_list, dente_4);

	gamba_dx_list = create_list(gamba_dx, "gamba_dx_list");
	gamba_dx_list = insert_in_list(gamba_dx_list, piede_dx);
	gamba_dx_list = insert_in_list(gamba_dx_list, unghia_dx_1);
	gamba_dx_list = insert_in_list(gamba_dx_list, unghia_dx_2);
	gamba_dx_list = insert_in_list(gamba_dx_list, unghia_dx_3);

	gamba_sx_list = create_list(gamba_sx, "gamba_sx_list");
	gamba_sx_list = insert_in_list(gamba_sx_list, piede_sx);
	gamba_sx_list = insert_in_list(gamba_sx_list, unghia_sx_1);
	gamba_sx_list = insert_in_list(gamba_sx_list, unghia_sx_2);
	gamba_sx_list = insert_in_list(gamba_sx_list, unghia_sx_3);

	pelle_list = create_list(braccio_dx_list, "pelle_list");
	pelle_list = insert_in_list(pelle_list, braccio_sx_list);
	pelle_list = insert_in_list(pelle_list, corpo_trimmato);
	pelle_list = insert_in_list(pelle_list, bocca_overlay);
	pelle_list = insert_in_list(pelle_list, labbro);
	pelle_list = insert_in_list(pelle_list, sopracciglio);
	pelle_list = insert_in_list(pelle_list, ciglio);
	pelle_list = insert_in_list(pelle_list, sottociglio);
	pelle_list = insert_in_list(pelle_list, gamba_dx);
	pelle_list = insert_in_list(pelle_list, gamba_sx);
	pelle_list = insert_in_list(pelle_list, piede_dx);
	pelle_list = insert_in_list(pelle_list, piede_sx);

	denti_list = create_list(dente_1, "denti_list");
	denti_list = insert_in_list(denti_list, dente_2);
	denti_list = insert_in_list(denti_list, dente_3);
	denti_list = insert_in_list(denti_list, dente_4);

	unghie_list = create_list(unghia_dx_1, "unghie_list");
	unghie_list = insert_in_list(unghie_list, unghia_dx_2);
	unghie_list = insert_in_list(unghie_list, unghia_dx_3);
	unghie_list = insert_in_list(unghie_list, unghia_sx_1);
	unghie_list = insert_in_list(unghie_list, unghia_sx_2);
	unghie_list = insert_in_list(unghie_list, unghia_sx_3);

	piede_dx_list = create_list(unghia_dx_1, "piede_dx_list");
	piede_dx_list = insert_in_list(piede_dx_list, unghia_dx_2);
	piede_dx_list = insert_in_list(piede_dx_list, unghia_dx_3);
	piede_dx_list = insert_in_list(piede_dx_list, piede_dx);

	piede_sx_list = create_list(unghia_sx_1, "piede_dx_list");
	piede_sx_list = insert_in_list(piede_sx_list, unghia_sx_2);
	piede_sx_list = insert_in_list(piede_sx_list, unghia_sx_3);
	piede_sx_list = insert_in_list(piede_sx_list, piede_sx);

	ambiente_list = create_list(porta_corpo,"ambiente_list");
	ambiente_list = insert_in_list(ambiente_list, porta_contorno);
	ambiente_list = insert_in_list(ambiente_list, pomello_porta);
	ambiente_list = insert_in_list(ambiente_list, sostegno_porta_dx);
	ambiente_list = insert_in_list(ambiente_list, sostegno_porta_sx);
	ambiente_list = insert_in_list(ambiente_list, lucina);
	ambiente_list = insert_in_list(ambiente_list, sostegno_bombola_sotto);
	ambiente_list = insert_in_list(ambiente_list, sostegno_bombola_sopra);
	ambiente_list = insert_in_list(ambiente_list, bombola);
	ambiente_list = insert_in_list(ambiente_list, bombola2);
	ambiente_list = insert_in_list(ambiente_list, ruota_sx);
	ambiente_list = insert_in_list(ambiente_list, ruota_dx);
	ambiente_list = insert_in_list(ambiente_list, pavimento);
	ambiente_list = insert_in_list(ambiente_list, soffitto);
	ambiente_list = insert_in_list(ambiente_list, fondo);
	ambiente_list = insert_in_list(ambiente_list, muro);
	ambiente_list = insert_in_list(ambiente_list, pinza_1);
	ambiente_list = insert_in_list(ambiente_list, pinza_2);
	ambiente_list = insert_in_list(ambiente_list, filo);

	porta_list = create_list(porta_corpo, "porta_list");
	porta_list = insert_in_list(porta_list, porta_contorno);
	porta_list = insert_in_list(porta_list, pomello_porta);
	porta_list = insert_in_list(porta_list, lucina);

	sostegni_list = create_list(sostegno_porta_dx,"ambiente_list");
	sostegni_list = insert_in_list(sostegni_list, sostegno_porta_sx);
	sostegni_list = insert_in_list(sostegni_list, ruota_dx);
	sostegni_list = insert_in_list(sostegni_list, ruota_sx);
	sostegni_list = insert_in_list(sostegni_list, sostegno_bombola_sopra);
	sostegni_list = insert_in_list(sostegni_list, sostegno_bombola_sotto);

	pinza_list = create_list(pinza_1, "pinza_list");
	pinza_list = insert_in_list(pinza_list, pinza_2);
	pinza_list = insert_in_list(pinza_list, filo);

	scena = create_list(braccio_dx_list,"scena");
	scena = insert_in_list(scena, braccio_sx_list);
	scena = insert_in_list(scena, corpo_list);
	scena = insert_in_list(scena, gamba_dx_list);
	scena = insert_in_list(scena, gamba_sx_list);
	scena = insert_in_list(scena, ambiente_list);

	mike = create_list(braccio_dx_list,"mike");
	mike = insert_in_list(mike, braccio_sx_list);
	mike = insert_in_list(mike, corpo_list);
	mike = insert_in_list(mike, gamba_dx_list);
	mike = insert_in_list(mike, gamba_sx_list);

	set_domain_texture(unghie_list, temp_attr, "textures/dente.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(corno_dx, temp_attr, "textures/dente.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(corno_sx, temp_attr, "textures/dente.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(occhio, temp_attr, "textures/occhio.hr",0,1,0,1,FALSE,0.5,0.5);
	set_domain_texture(denti_list, temp_attr, "textures/dente.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(pelle_list, temp_attr, "textures/prova.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(sostegni_list, temp_attr, "textures/ferro.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(porta_contorno, temp_attr, "textures/stipite.hr",0,1,0,1,TRUE,0.4,0.4);
	set_domain_texture(pomello_porta, temp_attr, "textures/legno.hr",0,1,0,1,TRUE,0.4,0.4);
	//set_domain_texture(porta_corpo, temp_attr, "textures/test.hr",0,1,0,1,TRUE,0.4,0.4);
	set_bump_texture(porta_corpo, temp_attr, "textures/porta_bumpmap.hr",0,1,0,1,FALSE,0.4,0.4);
	set_domain_texture(bombola, temp_attr, "textures/bombola.hr",0,1,0,1,TRUE,0.4,1);
	set_domain_texture(bombola2, temp_attr, "textures/bombola.hr",0,1,0,1,TRUE,0.4,1);
	//set_domain_texture(pavimento, temp_attr, "textures/pavimento.hr",0,1,0,1,TRUE,0.4,1);
	set_transparency(attr_lucina, 0.3,0.3, 0, 1.5);
	set_color(attr_lucina, 1,0.3,0.1, 0.4,0.4);
	set_attribute(lucina, attr_lucina);
	set_attribute(pavimento, colore_pavimento);
	set_attribute(muro, colore_muro);
	set_attribute(soffitto, colore_soffitto);
	//pavimento color puffo
	set_color(colore_pavimento, 0.19,0.73,1,1,1);
	set_color(colore_muro, 0.19,0.73,1,1,1);
	set_color(colore_soffitto, 0.19,0.73,1,1,1);
	set_projection_texture(fondo, temp_attr, "textures/serranda2.hr",1,TRUE,0.3,0.7);
	set_scale_abs(fondo, 500,500,500);

	//frame 1
	//mi porto più o meno di fronte alla porta

	set_z_rotate(mike, 150, 1);
	set_translate(mike, 50, -50, 0);

	save_scene("mike.md", "mike", scena);

	return(0);
}
